# coding=utf-8
import time
from time import sleep

from pylgbst import *
from pylgbst.comms import DebugServerConnection
from pylgbst.movehub import MoveHub, COLORS, COLOR_BLACK
from pylgbst.peripherals import EncodedMotor, TiltSensor, Amperage, Voltage


def checkports(movehub):
    global motor
    motor = None
    if isinstance(movehub.port_D, EncodedMotor): motor = movehub.port_D
    elif isinstance(movehub.port_C, EncodedMotor): motor = movehub.port_C
    else: print("No Motor attached to ports C or D")

def initialize(movehub):
    movehub.motor_B.angled(100, -1)
    motor.angled(660, .2)
    motor.angled(-20, .2)


########## MAIN PROGRAM #############

print("#### LEGO BOOST -- DOT-MATRIX-DRAWING-BOT  ####")
print("")
usrinput=input("Please enter your Dot-Matrix file name: ")
with open(usrinput, "r") as file:
    data = file.readlines()
print("")
print("Distance between dots (0 for default):")
a_dist=int(input("A-Motor (25): "))
if a_dist==0: a_dist=25
m_dist=int(input("Ext. Motor (20): "))
if m_dist==0: m_dist=20
print("A-Distance=",a_dist," M-Distance=",m_dist)
print ("") 
print ("Please press green button on MoveHub to Start")
try:
    connection = DebugServerConnection()
except BaseException:
    connection = get_connection_auto()

try:
    hub = MoveHub(connection)
    checkports(hub)
    initialize(hub)
    a = 0
    m = 0
    for line in data:
        dot = line.split()
        #print(dot[0:2])    
        hub.motor_A.angled((int(dot[1])-a)*a_dist, .25)
        a=int(dot[1])
        motor.angled((int(dot[0])-m)*m_dist*-1, 1)
        m=int(dot[0])
        hub.motor_B.angled(90, 1)
        hub.motor_B.angled(90, -1)      
finally:
    connection.disconnect()
